/* ---- CONTROLADOR DEL 8255 VIA PARALELO  */
/* ---- MODIFICADO 24-10-2001 --------------- */

#include <sys/io.h>

#include <sys/time.h>
#include <errno.h>
#include <time.h>
#include <stdlib.h> 
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <termio.h>
#include <termios.h>

#include "seta01x.h"


unsigned int z,zz,t,tt,i;
int on=1,off=0;


/* modoin=0 es modo standar para cualquier puerto paralelo
   modoin=1 es modo bidireccional, puede no funcionar
*/
void c_control(char a,char b,char c1,char c2);
unsigned char c_in(unsigned char p);
void c_out(unsigned char p, unsigned char d);
void control(void);

unsigned char modoin=0;
unsigned char xa,xb,xc1,xc2,da,db,dc;
char *led="**";


struct termios eta1,eta2;


main(int argc,char *argv[])
{
 unsigned char zc;
 unsigned char te,tez;

	if (ioperm(888,890-888+1 , 1)) {
	    printf("Cannot get I/O permissions.\n");
	    exit(-1);
		}
	ioctl(0,TCGETS,&eta1);
	eta2=eta1;
	eta2.c_lflag &=~(ECHO|ICANON);	ioctl(0,TCSETS,&eta2); /* no eco */
	ioctl(1,FIONBIO,&on); /* teclado no bloqueante */
        
	c_control(1,1,1,1);
	xa=xb=xc1=xc2=1;
inicio:

	color(39,0);cls();
	color(37,1);
	printc(24,0,"Programador del 8255");
	printc(24,21,"   (c) SETA 2001    ");
	color(37,46);
	printc(2,23,"Tecla x, cambio de modo");
	if(modoin==0) printc(50,23,"Modo standard           "); else 	 printc(50,23,"Modo Bidireccional");
	color(33,40);
	printc(2,5,"PUERTO A");
	printc(2,10,"PUERTO B");
	printc(2,15,"PUERTO C");
	color(34,40);
	printc(25,3,"D0 D1 D2 D3 D4 D5 D6 D7 ");
	printc(18,6,"Teclas  1  2  3  4  5  6  7  8");
	printc(18,11,"Teclas  q  w  e  r  t  y  u  i");
	printc(18,17,"Teclas  a  s  d  f  g  h  j  k");
	te=0; tez=1;
	while(te!=27)
	{
 espera(10);
	 tt=inkey2();
	 if(tt==1)te=VARI[0]; else te=0;
	 if(te>64 && te<91)te+=32;
	 if(te!=tez)
		{
		 switch(te)
			{
			 case '1':
				if(da&1) da-=1; else da+=1;
			 break;
			 case '2':
				if(da&2) da-=2; else da+=2;
			 break;
			 case '3':

				if(da&4) da-=4; else da+=4;

			 break;

			 case '4':

				if(da&8) da-=8; else da+=8;

			 break;

			 case '5':

				if(da&16) da-=16; else da+=16;

			 break;

			 case '6':

				if(da&32) da-=32; else da+=32;

			 break;

			 case '7':

				if(da&64) da-=64; else da+=64;

			 break;

			 case '8':

				if(da&128) da-=128; else da+=128;

			 break;



			 case 'q':

				if(db&1) db-=1; else db+=1;

			 break;

			 case 'w':

				if(db&2) db-=2; else db+=2;

			 break;

			 case 'e':

				if(db&4) db-=4; else db+=4;

			 break;

			 case 'r':

				if(db&8) db-=8; else db+=8;

			 break;

			 case 't':

				if(db&16) db-=16; else db+=16;

			 break;

			 case 'y':

				if(db&32) db-=32; else db+=32;

			 break;

			 case 'u':

				if(db&64) db-=64; else db+=64;

			 break;

			 case 'i':

				if(db&128) db-=128; else db+=128;

			 break;


             case 'a':

				if(dc&1) dc-=1; else dc+=1;

			 break;

			 case 's':

				if(dc&2) dc-=2; else dc+=2;

			 break;

			 case 'd':

				if(dc&4) dc-=4; else dc+=4;

			 break;

			 case 'f':

				if(dc&8) dc-=8; else dc+=8;

			 break;

			 case 'g':

				if(dc&16) dc-=16; else dc+=16;

			 break;

			 case 'h':

				if(dc&32) dc-=32; else dc+=32;

			 break;

			 case 'j':

				if(dc&64) dc-=64; else dc+=64;

			 break;

			 case 'k':

				if(dc&128) dc-=128; else dc+=128;

			 break;

			 case 'x':

			  control();

			  goto inicio;

			 break;

			}

		 if(xa>0) {color(32,40); printc(5,6,"ENTRADAS ");} else {color(31,40);;printc(5,6,"SALIDAS  ");}

		 if(xb>0) {color(32,40);printc(5,11,"ENTRADAS ");} else {color(31,40);printc(5,11,"SALIDAS  ");}

		 if(xc1|=0){color(32,40); printc(25,16,"C1-ENTRADAS ");} else {color(31,40);printc(25,16,"C1-SALIDAS  ");}

		 if(xc2|=0){color(32,40); printc(37,16,"C2-ENTRADAS ");} else {color(31,40);printc(37,16,"C2-SALIDAS  ");}

		 if(xa==0)

			{

			 zc=da;

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(31,40); else color(39,40);

				 printc(z,7,led); zc=zc>>1;

				}

			}

		 if(xb==0)

			{

			 zc=db;

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(31,40); else color(39,40);

				 printc(z,12,led); zc=zc>>1;

				}

			}

		 if(xc1==0 || xc2==0)

			{

			 zc=dc;

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(31,40); else color(39,40);

				 printc(z,18,led); zc=zc>>1;

				}

			}
			c_out('a',da);
			c_out('b',db);
			c_out('c',dc);

		 }



		 if(xa>0)

			{

			 zc=c_in('a');

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(32,40); else color(39,40);

				 printc(z,7,led); zc=zc>>1;

				}

			}



		 if(xb>0)

			{

			 zc=c_in('b');

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(32,40); else color(39,40);

				 printc(z,12,led); zc=zc>>1;

				}

			}

		 if(xc2>0 || xc1>0)

			{

			 zc=c_in('c');

			 for(z=25;z<49;z+=3)

				{

				 if(zc&1) color(32,40); else color(39,40);

				 printc(z,19,led); zc=zc>>1;

				}

			}



	 tez=te;

	 impri(0,0,32);

	 espera(16);




	 
	}
fin:
	ioctl(1,FIONBIO,&off); /* teclado bloqueante */	
	ioctl(0,TCSETSF,&eta1); /* teclado eco */
	color(0,49);
}





/* PANTALLA DE CONTROL DE PUERTOS */

void control(void)

{

unsigned char te,tez;
char zxa,zxb,zxc1,zxc2;
   	zxa=xa; zxb=xb; zxc1=xc1; zxc2=xc2;
	te=0;tez=1;

	while(1<2)

	{

	 te=inkey();

	 if(te!=tez)

	 {

	  cls();
	color(33,40);
	  printc(22,0,"Programador del 8255");


	color(36,40);
	  printc(2,5,"Tecla 1 ->PUERTO A");

	  printc(2,6,"Tecla 2 ->PUERTO B");

	  printc(2,7,"Tecla 3 ->PUERTO C1");

	  printc(2,8,"Tecla 4 ->PUERTO C2");

	  printc(2,9,"Tecla 5 ->MODO");
	color(33,40);
	  printc(2,18,"Tecla c ->Para confirmar, cualquier otra tecla cancela");

	  printc(2,19,"Cuidado, antes de colocar como salida comprobar antes la conexion.");

	  if(zxa>0) {color(32,40); printc(22,5,"ENTRADAS ");} else {color(31,40);printc(22,5,"SALIDAS  ");}

	  if(zxb>0) {color(32,40);printc(22,6,"ENTRADAS ");} else {color(31,40);printc(22,6,"SALIDAS  ");}

	  if(zxc1>0){color(32,40); printc(22,7,"C1-ENTRADAS ");} else {color(31,40);printc(22,7,"C1-SALIDAS  ");}

	  if(zxc2>0){color(32,40); printc(22,8,"C2-ENTRADAS ");} else {color(31,40);printc(22,8,"C2-SALIDAS  ");}

	  INK=15;

	  if(modoin==0) printc(22,9,"Modo standard           "); else 	 printc(22,9,"Modo Bidireccional");

	  switch(te)

			{

			 case '1':

				if(zxa!=0) zxa=0; else zxa=1;

			 break;

			 case '2':

				if(zxb!=0) zxb=0; else zxb=1;

			 break;

			 case '3':

				if(zxc1!=0) zxc1=0; else zxc1=1;

			 break;

			 case '4':

				if(zxc2!=0) zxc2=0; else zxc2=1;

			 break;

			 case '5':

				if(modoin!=0) modoin=0; else modoin=1;

			 break;

			 case 'c':
                            	xa=zxa; xb=zxb; xc1=zxc1; xc2=zxc2;

				c_control(xa,xb,xc1,xc2);

				goto fincontrol;

			 break;

			 case 0:

			 break;

			 default:

			 goto fincontrol;

			}

	 }

	 tez=te;

	}

fincontrol:

;

}


/* solo modo 0 de 8255 */

/* 0=salida  1=entrada */

void c_control(char a,char b,char c1,char c2)

{

unsigned char z;

	xa=xb=xc1=xc2=0;

	z=0;

	if(c2>0) {z=8; xc2=1;}

	if(b>0) {z+=2; xb=1;}

	if(c1>0) {z+=1; xc1=1;}

	if(a>0) {z+=16; xa=1;}

	z+=128;

	c_out('x',z);

}



unsigned char c_in(unsigned char p)

{

unsigned char c,c1,byte;

int z;

	byte=0;

	switch(p)

			{

			case 'a':

				 if(modoin==0)

				{

				 outportb(890,14);

				 outportb(890,15);

				 for(c1=0;c1<8;c1++)

					{

					 byte=byte>>1;

					 outportb(888,c1); outportb(888,c1);

					 c=inportb(889)&32; c=inportb(889)&32;

					 if(32==c) byte=byte|128;

					}

				 outportb(890,14);

                }

				 else

				 {

				  outportb(890,14);

				  outportb(890,15);

				   outportb(890,15+32);

				   byte=inportb(888);

				  outportb(890,14);

				 }

			 break;

			 case 'b':

				if(modoin==0)

				{

				 outportb(890,6);

				 outportb(890,7);

				 for(c1=0;c1<8;c1++)

					{

					 byte=byte>>1;

					 outportb(888,c1); outportb(888,c1);

					 c=inportb(889)&32; c=inportb(889)&32;

					 if(32==c) byte=byte|128;

					}

				  outportb(890,6);

				 }

				 else

				 {

				  outportb(890,6);

				 outportb(890,7);

				   outportb(890,7+32);

				   byte=inportb(888);

				 outportb(890,6);

				 }

			 break;

			 case 'c':

				if(modoin==0)

				{

				 outportb(890,12);

				 outportb(890,13);

				 for(c1=0;c1<8;c1++)

					{

					 byte=byte>>1;

					 outportb(888,c1); outportb(888,c1);

					 c=inportb(889)&32; c=inportb(889)&32;

					 if(32==c) byte=byte|128;

					}

				 outportb(890,12);

				}

				else

				{

				 outportb(890,12);

				 outportb(890,13);

				   outportb(890,13+32);

				   byte=inportb(888);

				 outportb(890,12);

				}

			 break;

			}

	return(byte);

}



/* p= a,b,c,x siendo x de control */

void c_out(unsigned char p, unsigned char d)

{

	switch(p)

			{

			 case 'a':

				da=d;

/*				printf("c_out A= %d\n",d); */

				outportb(890,14);

				outportb(888,d);

				outportb(890,10);

				outportb(890,14);

			 break;

			 case 'b':

				db=d;

/*				printf("c_out B= %d\n",d); */

				outportb(890,6);

				outportb(888,d);

				outportb(890,2);

				outportb(890,6);

			 break;

			 case 'c':

				dc=d;

/*				printf("c_out C= %d\n",d); */

				outportb(890,12);

				outportb(888,d);

				outportb(890,8);

				outportb(890,12);

			 break;

			 case 'x':

				printf("Control c_out %d\n",d);

				outportb(890,4);

				outportb(888,d);

				outportb(890,0);

				outportb(890,4);

			 break;

			}

}



