/* ---- seta01x.c			  --------------- */
/* ---- MODIFICADO 12-01-1998 --------------- */

#include <asm/io.h> 

#include <sys/time.h>
#include <errno.h>
#include <time.h>
#include <stdlib.h> 
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <termio.h>
#include <termios.h>



int inkey(void);
unsigned int inkey2(void);
void locate(int x,int y);
void cls(void);
void color(int d1,int d2);
void impri(int x,int y, unsigned char c);
void printc(int x,int y, char *cade);
void printn(int x,int y,unsigned long int num);
void inputc(int x,int y,unsigned char nombre[40]);
void espera(unsigned long usec);
void velocidad(void);
void error(int z);


char VARI[160],CADE[20];
struct termios eta1,eta2;

int INK,PAPER,SPEED,XMOUSE,YMOUSE,KMOUSE,CMOUSE,MX,MY,MK;
FILE *pf;
unsigned char *pv,*pv1;




unsigned char inportb(unsigned short port)
{
unsigned char z;
	__asm__("
	  pushw %%dx\n
	  pushw %%ax\n
	  movw %1,%%dx\n
	  inb %%dx,%%al\n
	  movb %%al,%0\n
	  popw %%ax\n
	  popw %%dx"
	  : "=g" (z)
	  :  "g" (port)
	  : "ax","dx"
	);
	return(z);
}

void outportb(unsigned short port, unsigned char value)
{
	__asm__("
	  pushw %%dx\n
	  pushw %%ax\n
	  movw %1,%%dx\n
	  movb %0,%%al\n
	  outb %%al,%%dx\n
	  popw %%ax\n
	  popw %%dx"
	  :
	  : "g" (value), "g" (port)
	  : "ax","dx"
	);
} 


/* ------ Tratamiento de errores ----- */
void error(int z)
{
	cls();
	switch(z)
		{
		 case 2:
			printc(0,0,"Fichero no encontrado");
			break;
		 case 8:
			printc(0,0,"Memoria insuficiente");
			break;
		 case 13:
			printc(0,0,"Dato invalido");
			break;
		 default:
			printc(0,0,"Error desconocido");
			break;
		}
	while(inkey()==0);
	printf("\n");
}

void espera(unsigned long usec)
{
 struct timeval timeout;
  timeout.tv_sec = usec / 1000000;
  timeout.tv_usec = usec - 1000000 * timeout.tv_sec;
  select (1, NULL, NULL, NULL, &timeout);
}

int inkey(void)
{
char c;
int zz;
 	read(0,&c,1);
 	zz=0; zz=c;
	return(zz);
}

unsigned int inkey2(void)
{
int z;
	for(z=0;z<10;z++)VARI[z]=0;
	z=0;
volver: 
	VARI[z]=inkey(); impri(79,24,0);
	if(VARI[z]!=0 && z<10){z++; goto volver;}
	return(z);
}
void printc(int x,int y, char *cade)
{
	locate(x,y);
	write(1,cade,strlen(cade));
}
void printn(int x,int y,unsigned long int num)
{
	locate(x,y);
	sprintf(VARI,"%d",num);
	write(1,VARI,strlen(VARI));
}
void impri(int x,int y, unsigned char c)
{
	locate(x,y);
	write(1,&c,1);
}

void cls()
{
	sprintf(CADE,"%c[H%c[J%c[H",27,27,27);
	write(1,CADE,strlen(CADE));
}

void locate(int x,int y)
{
	x++;y++;
	sprintf(CADE,"%c[%u;%uH",27,y,x); 
	write(1,CADE,strlen(CADE));
}
void color(int d1,int d2)
{
	sprintf(CADE,"%c[%um%c[%um",27,d1,27,d2);	
	write(1,CADE,strlen(CADE));
}


/* ---- LEE CADENA DEL TECLADO ----*/
void inputc(int x,int y,unsigned char nombre[40])
{
int z,zz,n;
	printc(x,y,nombre);
	for(z=0;z<40&&nombre[z]!=0;z++);
	x=x+z;	z=x; n=0; zz=0;
	locate(x,y);
	while(zz!=10)
		{
		 zz=inkey();
		 if(zz==10 || zz==27) goto fin;
		 if(zz!=0)
			{
			 if(zz==127)
				{
				 if(n!=0){z--;n--;impri(z,y,32);}
				}
				else
				{
				 impri(z,y,zz);
				 if(n<38){z++; VARI[n]=zz; n++; locate(z,y);}
				}
			}
		}
fin:
	VARI[n]=0;
}

void velocidad(void)
{
long Sti;
unsigned ti;
	Sti=0;
	printc(0,0,"ESPERA UN MOMENTO");
	ti=time(NULL);
	while(ti==time(NULL));
	ti=time(NULL);
	while(ti==time(NULL))Sti++;
	SPEED=Sti/1000;
}
